/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: AccessCCDFP.h /main/4 1995/12/18 16:29:51 cde-hp $ */
/************************************<+>*************************************
 ****************************************************************************
 **
 **   File:        AccessCCDFP.h
 **
 **   Project:     Run Time Project File Access
 **
 **  
 **   Description: Private header file for AccessCCDFP.h
 **
 **  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 Hewlett-Packard Company
 **
 **  (c) Copyright 1993, 1994 Hewlett-Packard Company
 **  (c) Copyright 1993, 1994 International Business Machines Corp.
 **  (c) Copyright 1993, 1994 Sun Microsystems, Inc.
 **  (c) Copyright 1993, 1994 Novell, Inc.
 **
 **
 ****************************************************************************
 ************************************<+>*************************************/
#ifndef _DtAccessCcdfP_h
#define _DtAccessCcdfP_h

/*
 * The following structure holds loaded volumes.  The fields of this 
 * structure should not be accessed by any code outside of the volume
 * module.
 */
struct _CcdfVolumeInfo {
    XrmDatabase volDb;		/* A pointer to the Resource Manager */
				/* database that was loaded from the */
				/* volume file.  */

    char **topicList;		/* A pointer to a string array containing */
				/* the locationIDs for all of the topics */
				/* in the volume.  This array is not created */
				/* until the first time it is needed. */

    char *keywordFile;		/* A pointer to the name of the keyword */
				/* file.  This name is generated by */
				/* adding "k" to the end of volFile. */
				/* This filename is not generated until */
				/* the first time it is needed. */
};

typedef struct _CcdfVolumeInfo *CcdfVolumePtr;

#endif /* _DtAccessCcdfP_h */
