/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: HelpDialogImageI.h /main/3 1995/10/26 12:24:20 rswiston $ */
/*************************************<+>*************************************
 *****************************************************************************
 **
 **  File:   HelpDialogImageI.h
 **
 **  Project:  Cache Creek (Rivers) Project:
 **
 **  Description:  Internal image header file for HelpDialog Widget.
 **  -----------
 **
 **  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 Hewlett-Packard Company
 **
 **  (c) Copyright 1993, 1994 Hewlett-Packard Company
 **  (c) Copyright 1993, 1994 International Business Machines Corp.
 **  (c) Copyright 1993, 1994 Sun Microsystems, Inc.
 **  (c) Copyright 1993, 1994 Novell, Inc.
 **
 *******************************************************************
 *************************************<+>*************************************/
#ifndef _HelpDialogImageI_h
#define _HelpDialogImageI_h



/*****************************************************************************
 * Image: Tool Box Back Button (sensatized)
 *
 *****************************************************************************/
#define back_width 22
#define back_height 22
static char back_bits[] = {
   0x00, 0x02, 0x00, 0x00, 0x04, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x14, 0x00,
   0xaa, 0x2a, 0x0f, 0x54, 0x55, 0x1f, 0xaa, 0x2a, 0x1f, 0x00, 0x14, 0x1c,
   0x00, 0x0a, 0x1c, 0x00, 0x04, 0x1c, 0x00, 0x02, 0x1c, 0x40, 0x00, 0x1c,
   0x60, 0x00, 0x1c, 0x70, 0x00, 0x1c, 0x78, 0x00, 0x1c, 0xfc, 0xff, 0x1f,
   0xfe, 0xff, 0x1f, 0xfc, 0xff, 0x0f, 0x78, 0x00, 0x00, 0x70, 0x00, 0x00,
   0x60, 0x00, 0x00, 0x40, 0x00, 0x00};





/*****************************************************************************
 * Image: Tool Box Back Button (de-sensatized)
 *
 *****************************************************************************/
#define backD_width 22
#define backD_height 22
static char backD_bits[] = {
   0x00, 0x02, 0x00, 0x00, 0x04, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x14, 0x00,
   0xaa, 0x2a, 0x0a, 0x54, 0x55, 0x15, 0xaa, 0x2a, 0x0a, 0x00, 0x14, 0x14,
   0x00, 0x0a, 0x08, 0x00, 0x04, 0x14, 0x00, 0x02, 0x08, 0x40, 0x00, 0x14,
   0x20, 0x00, 0x08, 0x50, 0x00, 0x14, 0x28, 0x00, 0x08, 0x54, 0x55, 0x15,
   0xaa, 0xaa, 0x0a, 0x54, 0x55, 0x05, 0x28, 0x00, 0x00, 0x50, 0x00, 0x00,
   0x20, 0x00, 0x00, 0x40, 0x00, 0x00};



/*****************************************************************************
 * Image: Tool Box Top Button (sensatized)
 *
 *****************************************************************************/
#define top_width 22
#define top_height 22
static char top_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0xff, 0x00, 0xfc, 0x7f, 0x00,
   0xfc, 0x3f, 0x00, 0xfc, 0x1f, 0x00, 0xfc, 0x0f, 0x00, 0xfc, 0x07, 0x00,
   0xfc, 0x0f, 0x00, 0xfc, 0x1f, 0x00, 0xfc, 0x3f, 0x00, 0x7c, 0x7f, 0x00,
   0x3c, 0xfe, 0x00, 0x1c, 0xfc, 0x01, 0x0c, 0xf8, 0x03, 0x04, 0xf0, 0x01,
   0x00, 0xe0, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};



/*****************************************************************************
 * Image: Tool Box Top Button (de-sensatized)
 *
 *****************************************************************************/
#define topD_width 22
#define topD_height 22
static char topD_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa8, 0xaa, 0x00, 0x54, 0x55, 0x00,
   0xa8, 0x2a, 0x00, 0x54, 0x15, 0x00, 0xa8, 0x0a, 0x00, 0x54, 0x05, 0x00,
   0xa8, 0x0a, 0x00, 0x54, 0x15, 0x00, 0xa8, 0x2a, 0x00, 0x54, 0x55, 0x00,
   0x28, 0xaa, 0x00, 0x14, 0x54, 0x01, 0x08, 0xa8, 0x00, 0x04, 0x50, 0x00,
   0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00};





/*****************************************************************************
 * Image: Tool Box History Button (sensatized)
 *
 *****************************************************************************/
#define history_width 22
#define history_height 22
static char history_bits[] = {
   0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x30, 0x00, 0x00, 0x7e, 0x54, 0x15,
   0x7e, 0xa8, 0x0a, 0x30, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x10, 0x00, 0x00, 0x30, 0x00, 0x00, 0x7e, 0x54, 0x15, 0x7e, 0xa8, 0x0a,
   0x30, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00,
   0x30, 0x00, 0x00, 0x7e, 0x54, 0x15, 0x7e, 0xa8, 0x0a, 0x30, 0x00, 0x00,
   0x10, 0x00, 0x00, 0x00, 0x00, 0x00};


/*****************************************************************************
 * Image: Tool Box History Button (de-sensatized)
 *
 *****************************************************************************/
#define historyD_width 22
#define historyD_height 22
static char historyD_bits[] = {
   0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x20, 0x00, 0x00, 0x54, 0x54, 0x15,
   0x2a, 0xa8, 0x0a, 0x20, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x10, 0x00, 0x00, 0x20, 0x00, 0x00, 0x54, 0x54, 0x15, 0x2a, 0xa8, 0x0a,
   0x20, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00,
   0x20, 0x00, 0x00, 0x54, 0x54, 0x15, 0x2a, 0xa8, 0x0a, 0x20, 0x00, 0x00,
   0x10, 0x00, 0x00, 0x00, 0x00, 0x00};




/*****************************************************************************
 * Image: Tool Box Keyword Index Button (sensatized)
 *
 *****************************************************************************/
#define key_width 22
#define key_height 22
static char key_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x0e,
   0x00, 0x00, 0x07, 0x00, 0x80, 0x0f, 0x00, 0xc0, 0x1d, 0x00, 0xe0, 0x38,
   0x00, 0xf0, 0x11, 0x00, 0xb8, 0x03, 0x00, 0x1c, 0x07, 0x00, 0x0e, 0x02,
   0x00, 0x07, 0x00, 0x80, 0x03, 0x00, 0xfc, 0x01, 0x00, 0xfe, 0x00, 0x00,
   0xe6, 0x00, 0x00, 0xc6, 0x00, 0x00, 0xce, 0x00, 0x00, 0xfc, 0x00, 0x00,
   0x78, 0x00, 0x00, 0x00, 0x00, 0x00};



/*****************************************************************************
 * Image: Tool Box Keyword Index Button (de-sensatized)
 *
 *****************************************************************************/
#define keyD_width 22
#define keyD_height 22
static char keyD_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x0a,
   0x00, 0x00, 0x05, 0x00, 0x80, 0x0a, 0x00, 0x40, 0x15, 0x00, 0xa0, 0x28,
   0x00, 0x50, 0x11, 0x00, 0xa8, 0x02, 0x00, 0x14, 0x05, 0x00, 0x0a, 0x02,
   0x00, 0x05, 0x00, 0x80, 0x02, 0x00, 0x54, 0x01, 0x00, 0xaa, 0x00, 0x00,
   0x84, 0x00, 0x00, 0x42, 0x00, 0x00, 0x84, 0x00, 0x00, 0x54, 0x00, 0x00,
   0x28, 0x00, 0x00, 0x00, 0x00, 0x00};



#endif /* _HelpDialogImageI_h */
/* Do not add anything after this endif. */














