/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */

#ifndef _name_consts_h 
#define _name_consts_h 1

#define BREAK "BREAK"
#define LINE_BREAK "LINE"
#define COLUMN_BREAK "COLUMN"
#define PAGE_BREAK "PAGE"
#define LINE_AFTER_BREAK "LINEAFTER"
#define COLUMN_AFTER_BREAK "COLUMNAFTER"
#define PAGE_AFTER_BREAK "PAGEAFTER"


#define FONT "FONT"
#define FONT_FAMILY "FAMILY"
#define FONT_WEIGHT "WEIGHT"
#define FONT_SLANT "SLANT"
#define FONT_SIZE "SIZE"
#define FONT_XLFD "XLFD"
#define FONT_SUBSCRIPT "SUBSCRIPT"
#define FONT_SUPERSCRIPT "SUPERSCRIPT"

#define FONT_WEIGHT_MEDIUM "MEDIUM"
#define FONT_WEIGHT_BOLD "BOLD"
#define FONT_SLANT_ROMAN "ROMAN"
#define FONT_SLANT_ITALIC "ITALIC"
#define FONT_FAMILY_HELVETICA "HELVETICA"


#define FOOTNOTES "FOOTNOTE"

#define PARA "PARA"
#define COLUMNS "COLUMNS"
#define ONE_COLUMN "ONE"
#define TWO_COLUMN "TWO"
#define LEADING "LEADING"

#define GRAPHIC "GRAPHIC"
#define GRAPHIC_TYPE "GRTYPE"
#define GRAPHIC_ALIGN "ALIGN"
#define GRAPHIC_ALIGN_MIDDLE "INLINE"
#define GRAPHIC_ALIGN_BLOCK "BLOCK"
#define GRAPHIC_ALIGN_TOP "TOP"
#define GRAPHIC_ALIGN_BOTTOM "BOTTOM"

#define HEADERS "HEADER"
#define FOOTERS "FOOTER"
#define HEADER "CONTENT"
#define FOOTER "CONTENT"


#define HIGHLIGHT "HIGHLIGHT"
#define HIGHLIGHT_BOXED "BOXED"
#define HIGHLIGHT_STRIKE "STRIKE-THROUGH"
#define HIGHLIGHT_OVERLINE "OVERLINE"
#define HIGHLIGHT_UNDERLINE "UNDERLINE"

#define INDENT "INDENT"

#define IGNORE "IGNORE"

#define LAYOUT "LAYOUT"
#define LAYOUT_WIDTH "WIDTH"
#define LAYOUT_HEIGHT "HEIGHT"
#define LAYOUT_LEFT "LEFT"
#define LAYOUT_RIGHT "RIGHT"
#define LAYOUT_TOP "TOP"
#define LAYOUT_BOTTOM "BOTTOM"
#define LAYOUT_CENTERED "CENTERED"

#define LINE_WRAPPING "WRAP"
#define WRAP_CHAR "CHAR"
#define WRAP_WORD "WORD"
#define WRAP_NONE "NONE"
#define WRAP_HYPHENATION "HYPHENATION"

#define LOCATOR "LOCATOR"

#define MARGIN "MARGIN"
#define MARGIN_LEFT "LEFT"
#define MARGIN_RIGHT "RIGHT"
#define MARGIN_TOP "TOP"
#define MARGIN_BOTTOM "BOTTOM"

#define MEDIA "MEDIUM"

#define MEDIA_SIZE "SIZE"
#define MEDIA_SIZE_USLETTER "LETTER"
#define MEDIA_SIZE_USLEGAL "LEGAL"
#define MEDIA_SIZE_TABLOID "TABLOID"
#define MEDIA_SIZE_LEDGER "LEDGER"
#define MEDIA_SIZE_STATEMENT "STATEMENT"
#define MEDIA_SIZE_Executive "EXECUTIVE"
#define MEDIA_SIZE_A3 "A3"
#define MEDIA_SIZE_A4 "A4"
#define MEDIA_SIZE_A5 "A5"
#define MEDIA_SIZE_B4 "B4"
#define MEDIA_SIZE_B5 "B5"
#define MEDIA_SIZE_FOLIO "FOLIO"
#define MEDIA_SIZE_QUARTO "QUARTO"

#define MEDIA_ORIENTATION "ORIENTATION"
#define MEDIA_ORIENTATION_PORTRAIT "PORTRAIT"
#define MEDIA_ORIENTATION_LANDSCAPE "LANDSCAPE"


#define PREFIX "PREFIX"
#define PREFIX_CONTENT "CONTENT"
#define PREFIX_POSITION "POSITION"

#define POSTFIX "SUFFIX"
#define POSTFIX "SUFFIX"
#define POSTFIX_CONTENT "CONTENT"
#define POSTFIX_POSITION "POSITION"

#define QUADDING "QUADDING"
#define QUADDING_ASIS "ASIS"
#define QUADDING_LEFT "LEFT"
#define QUADDING_RIGHT "RIGHT"
#define QUADDING_FULL "FULL"
#define QUADDING_CENTERED "CENTERED"

#define TAB "TAB"

#define AUTO_NUMBER "AUTONUMBER"
#define AUTO_NUMBER_NUMERIC "ARABIC"
#define AUTO_NUMBER_ALPHABETIC_UPPERCASE "UCALPHA"
#define AUTO_NUMBER_ALPHABETIC_LOWERCASE "LCALPHA"
#define AUTO_NUMBER_ROMAN_UPPERCASE "UCROMAN"
#define AUTO_NUMBER_ROMAN_LOWERCASE "LCROMAN"

#endif


